字符串

151 字符串反转

151. Reverse Words in a String
Given an input string, reverse the string word by word.

Example 1: Input:the sky is blueOutput: blue is sky the

Example 2: Input: “ hello world! “ Output: “world! hello” Explanation: Your reversed string should not contain leading or trailing spaces.

Example 3:

Input: “a good example”

Output: “example good a”

Explanation: You need to reduce multiple spaces between two words to a single space in the reversed string.

Note:

  • A word is defined as a sequence of non-space characters.
  • Input string may contain leading or trailing spaces. However, your reversed string should not contain leading or trailing spaces.
  • You need to reduce multiple spaces between two words to a single space in the reversed string.

Follow up:

For C programmers, try to solve it in-place in O(1) extra space.

  1. class Solution(object):
  2. def reverseWords(self, s):
  3. """
  4. :type s: str
  5. :rtype: str
  6. """
  7. slist = s.split()
  8. revertlist = slist[::-1]
  9. ret=""
  10. for tmp in revertlist:
  11. ret += tmp + " "
  12. return ret[:-1]

collections

这个模块实现了特定目标的容器,以提供Python标准内建容器 dict , list , set , 和 tuple 的替代选择。

namedtuple() 创建命名元组子类的工厂函数
deque 类似列表(list)的容器,实现了在两端快速添加(append)和弹出(pop)
ChainMap 类似字典(dict)的容器类,将多个映射集合到一个视图里面
Counter 字典的子类,提供了可哈希对象的计数功能
OrderedDict 字典的子类,保存了他们被添加的顺序
defaultdict 字典的子类,提供了一个工厂函数,为字典查询提供一个默认值
UserDict 封装了字典对象,简化了字典子类化
UserList 封装了列表对象,简化了列表子类化
UserString 封装了列表对象,简化了字符串子类化

Counter

class collections.Counter([iterable-or-mapping])

一个 Counter 是一个 dict 的子类,用于计数可哈希对象。它是一个集合,元素像字典键(key)一样存储,它们的计数存储为值。计数可以是任何整数值,包括0和负数。 Counter 类有点像其他语言中的 bags或multisets。

  1. >>> from collections import Counter
  2. >>> c = Counter() # a new, empty counter
  3. >>> c
  4. Counter()
  5. >>> c = Counter('gallahad') # a new counter from an iterable
  6. >>> c
  7. Counter({'a': 3, 'l': 2, 'g': 1, 'h': 1, 'd': 1})
  8. >>> c = Counter({'red':4, 'blue': 2}) # a new counter from a mapping
  9. >>> c
  10. Counter({'red': 4, 'blue': 2})
  11. >>> c = Counter(cats=4, dogs=8) # a new counter from keywords args
  12. >>> c
  13. Counter({'dogs': 8, 'cats': 4})

347 前K个高频元素

347. 前 K 个高频元素

给定一个非空的整数数组,返回其中出现频率前 k 高的元素。

示例 1:

输入: nums = [1,1,1,2,2,3], k = 2

输出: [1,2]

示例 2:

输入: nums = [1], k = 1

输出: [1]

提示:

你可以假设给定的 k 总是合理的,且 1 ≤ k ≤ 数组中不相同的元素的个数。

你的算法的时间复杂度必须优于 O(n log n) , n 是数组的大小。

题目数据保证答案唯一,换句话说,数组中前 k 个高频元素的集合是唯一的。

你可以按任意顺序返回答案。

来源:力扣(LeetCode)

链接:https://leetcode-cn.com/problems/top-k-frequent-elements

著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。

方法一:Heap

image.png

  1. from collections import Counter
  2. class Solution:
  3. def topKFrequent(self, nums: List[int], k: int) -> List[int]:
  4. # O(1) time
  5. if k == len(nums):
  6. return nums
  7. # 1. build hash map : character and how often it appears
  8. # O(N) time
  9. count = Counter(nums)
  10. # 2-3. build heap of top k frequent elements and
  11. # convert it into an output array
  12. # O(N log k) time
  13. return heapq.nlargest(k, count.keys(), key=count.get)

复杂度分析
时间复杂度:O(Nlog(k))。Counter 方法的复杂度是 O(N),建堆和输出的复杂度是 O(Nlog(k))。因此总复杂度为 O(N + N log(k)) =O(Nlog(k))。
空间复杂度:O(N)O(N),存储哈希表的开销。
注释
根据复杂度分析,方法对于小 k 的情况是很优的。但是如果 k 值很大,我们可以将算法改成删除频率最低的若干个元素。

方法二:Quickselect

Hoare’s selection algorithm

Quickselect is a textbook algorthm typically used to solve the problems “find kth something”: kth smallest, kth largest, kth most frequent, kth less frequent, etc. Like quicksort, quickselect was developed by Tony Hoare, and also known as Hoare’s selection algorithm.

参考资料

Lib/heapq.py

  1. # -*- coding: latin-1 -*-
  2. """Heap queue algorithm (a.k.a. priority queue).
  3. Heaps are arrays for which a[k] <= a[2*k+1] and a[k] <= a[2*k+2] for
  4. all k, counting elements from 0. For the sake of comparison,
  5. non-existing elements are considered to be infinite. The interesting
  6. property of a heap is that a[0] is always its smallest element.
  7. Usage:
  8. heap = [] # creates an empty heap
  9. heappush(heap, item) # pushes a new item on the heap
  10. item = heappop(heap) # pops the smallest item from the heap
  11. item = heap[0] # smallest item on the heap without popping it
  12. heapify(x) # transforms list into a heap, in-place, in linear time
  13. item = heapreplace(heap, item) # pops and returns smallest item, and adds
  14. # new item; the heap size is unchanged
  15. Our API differs from textbook heap algorithms as follows:
  16. - We use 0-based indexing. This makes the relationship between the
  17. index for a node and the indexes for its children slightly less
  18. obvious, but is more suitable since Python uses 0-based indexing.
  19. - Our heappop() method returns the smallest item, not the largest.
  20. These two make it possible to view the heap as a regular Python list
  21. without surprises: heap[0] is the smallest item, and heap.sort()
  22. maintains the heap invariant!
  23. """
  24. # Original code by Kevin O'Connor, augmented by Tim Peters and Raymond Hettinger
  25. __about__ = """Heap queues
  26. [explanation by Fran�ois Pinard]
  27. Heaps are arrays for which a[k] <= a[2*k+1] and a[k] <= a[2*k+2] for
  28. all k, counting elements from 0. For the sake of comparison,
  29. non-existing elements are considered to be infinite. The interesting
  30. property of a heap is that a[0] is always its smallest element.
  31. The strange invariant above is meant to be an efficient memory
  32. representation for a tournament. The numbers below are `k', not a[k]:
  33. 0
  34. 1 2
  35. 3 4 5 6
  36. 7 8 9 10 11 12 13 14
  37. 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30
  38. In the tree above, each cell `k' is topping `2*k+1' and `2*k+2'. In
  39. a usual binary tournament we see in sports, each cell is the winner
  40. over the two cells it tops, and we can trace the winner down the tree
  41. to see all opponents s/he had. However, in many computer applications
  42. of such tournaments, we do not need to trace the history of a winner.
  43. To be more memory efficient, when a winner is promoted, we try to
  44. replace it by something else at a lower level, and the rule becomes
  45. that a cell and the two cells it tops contain three different items,
  46. but the top cell "wins" over the two topped cells.
  47. If this heap invariant is protected at all time, index 0 is clearly
  48. the overall winner. The simplest algorithmic way to remove it and
  49. find the "next" winner is to move some loser (let's say cell 30 in the
  50. diagram above) into the 0 position, and then percolate this new 0 down
  51. the tree, exchanging values, until the invariant is re-established.
  52. This is clearly logarithmic on the total number of items in the tree.
  53. By iterating over all items, you get an O(n ln n) sort.
  54. A nice feature of this sort is that you can efficiently insert new
  55. items while the sort is going on, provided that the inserted items are
  56. not "better" than the last 0'th element you extracted. This is
  57. especially useful in simulation contexts, where the tree holds all
  58. incoming events, and the "win" condition means the smallest scheduled
  59. time. When an event schedule other events for execution, they are
  60. scheduled into the future, so they can easily go into the heap. So, a
  61. heap is a good structure for implementing schedulers (this is what I
  62. used for my MIDI sequencer :-).
  63. Various structures for implementing schedulers have been extensively
  64. studied, and heaps are good for this, as they are reasonably speedy,
  65. the speed is almost constant, and the worst case is not much different
  66. than the average case. However, there are other representations which
  67. are more efficient overall, yet the worst cases might be terrible.
  68. Heaps are also very useful in big disk sorts. You most probably all
  69. know that a big sort implies producing "runs" (which are pre-sorted
  70. sequences, which size is usually related to the amount of CPU memory),
  71. followed by a merging passes for these runs, which merging is often
  72. very cleverly organised[1]. It is very important that the initial
  73. sort produces the longest runs possible. Tournaments are a good way
  74. to that. If, using all the memory available to hold a tournament, you
  75. replace and percolate items that happen to fit the current run, you'll
  76. produce runs which are twice the size of the memory for random input,
  77. and much better for input fuzzily ordered.
  78. Moreover, if you output the 0'th item on disk and get an input which
  79. may not fit in the current tournament (because the value "wins" over
  80. the last output value), it cannot fit in the heap, so the size of the
  81. heap decreases. The freed memory could be cleverly reused immediately
  82. for progressively building a second heap, which grows at exactly the
  83. same rate the first heap is melting. When the first heap completely
  84. vanishes, you switch heaps and start a new run. Clever and quite
  85. effective!
  86. In a word, heaps are useful memory structures to know. I use them in
  87. a few applications, and I think it is good to keep a `heap' module
  88. around. :-)
  89. --------------------
  90. [1] The disk balancing algorithms which are current, nowadays, are
  91. more annoying than clever, and this is a consequence of the seeking
  92. capabilities of the disks. On devices which cannot seek, like big
  93. tape drives, the story was quite different, and one had to be very
  94. clever to ensure (far in advance) that each tape movement will be the
  95. most effective possible (that is, will best participate at
  96. "progressing" the merge). Some tapes were even able to read
  97. backwards, and this was also used to avoid the rewinding time.
  98. Believe me, real good tape sorts were quite spectacular to watch!
  99. From all times, sorting has always been a Great Art! :-)
  100. """
  101. __all__ = ['heappush', 'heappop', 'heapify', 'heapreplace', 'merge',
  102. 'nlargest', 'nsmallest', 'heappushpop']
  103. from itertools import islice, count, imap, izip, tee, chain
  104. from operator import itemgetter
  105. def cmp_lt(x, y):
  106. # Use __lt__ if available; otherwise, try __le__.
  107. # In Py3.x, only __lt__ will be called.
  108. return (x < y) if hasattr(x, '__lt__') else (not y <= x)
  109. def heappush(heap, item):
  110. """Push item onto heap, maintaining the heap invariant."""
  111. heap.append(item)
  112. _siftdown(heap, 0, len(heap)-1)
  113. def heappop(heap):
  114. """Pop the smallest item off the heap, maintaining the heap invariant."""
  115. lastelt = heap.pop() # raises appropriate IndexError if heap is empty
  116. if heap:
  117. returnitem = heap[0]
  118. heap[0] = lastelt
  119. _siftup(heap, 0)
  120. else:
  121. returnitem = lastelt
  122. return returnitem
  123. def heapreplace(heap, item):
  124. """Pop and return the current smallest value, and add the new item.
  125. This is more efficient than heappop() followed by heappush(), and can be
  126. more appropriate when using a fixed-size heap. Note that the value
  127. returned may be larger than item! That constrains reasonable uses of
  128. this routine unless written as part of a conditional replacement:
  129. if item > heap[0]:
  130. item = heapreplace(heap, item)
  131. """
  132. returnitem = heap[0] # raises appropriate IndexError if heap is empty
  133. heap[0] = item
  134. _siftup(heap, 0)
  135. return returnitem
  136. def heappushpop(heap, item):
  137. """Fast version of a heappush followed by a heappop."""
  138. if heap and cmp_lt(heap[0], item):
  139. item, heap[0] = heap[0], item
  140. _siftup(heap, 0)
  141. return item
  142. def heapify(x):
  143. """Transform list into a heap, in-place, in O(len(x)) time."""
  144. n = len(x)
  145. # Transform bottom-up. The largest index there's any point to looking at
  146. # is the largest with a child index in-range, so must have 2*i + 1 < n,
  147. # or i < (n-1)/2. If n is even = 2*j, this is (2*j-1)/2 = j-1/2 so
  148. # j-1 is the largest, which is n//2 - 1. If n is odd = 2*j+1, this is
  149. # (2*j+1-1)/2 = j so j-1 is the largest, and that's again n//2-1.
  150. for i in reversed(xrange(n//2)):
  151. _siftup(x, i)
  152. def _heappushpop_max(heap, item):
  153. """Maxheap version of a heappush followed by a heappop."""
  154. if heap and cmp_lt(item, heap[0]):
  155. item, heap[0] = heap[0], item
  156. _siftup_max(heap, 0)
  157. return item
  158. def _heapify_max(x):
  159. """Transform list into a maxheap, in-place, in O(len(x)) time."""
  160. n = len(x)
  161. for i in reversed(range(n//2)):
  162. _siftup_max(x, i)
  163. def nlargest(n, iterable):
  164. """Find the n largest elements in a dataset.
  165. Equivalent to: sorted(iterable, reverse=True)[:n]
  166. """
  167. if n < 0:
  168. return []
  169. it = iter(iterable)
  170. result = list(islice(it, n))
  171. if not result:
  172. return result
  173. heapify(result)
  174. _heappushpop = heappushpop
  175. for elem in it:
  176. _heappushpop(result, elem)
  177. result.sort(reverse=True)
  178. return result
  179. def nsmallest(n, iterable):
  180. """Find the n smallest elements in a dataset.
  181. Equivalent to: sorted(iterable)[:n]
  182. """
  183. if n < 0:
  184. return []
  185. it = iter(iterable)
  186. result = list(islice(it, n))
  187. if not result:
  188. return result
  189. _heapify_max(result)
  190. _heappushpop = _heappushpop_max
  191. for elem in it:
  192. _heappushpop(result, elem)
  193. result.sort()
  194. return result
  195. # 'heap' is a heap at all indices >= startpos, except possibly for pos. pos
  196. # is the index of a leaf with a possibly out-of-order value. Restore the
  197. # heap invariant.
  198. def _siftdown(heap, startpos, pos):
  199. newitem = heap[pos]
  200. # Follow the path to the root, moving parents down until finding a place
  201. # newitem fits.
  202. while pos > startpos:
  203. parentpos = (pos - 1) >> 1
  204. parent = heap[parentpos]
  205. if cmp_lt(newitem, parent):
  206. heap[pos] = parent
  207. pos = parentpos
  208. continue
  209. break
  210. heap[pos] = newitem
  211. # The child indices of heap index pos are already heaps, and we want to make
  212. # a heap at index pos too. We do this by bubbling the smaller child of
  213. # pos up (and so on with that child's children, etc) until hitting a leaf,
  214. # then using _siftdown to move the oddball originally at index pos into place.
  215. #
  216. # We *could* break out of the loop as soon as we find a pos where newitem <=
  217. # both its children, but turns out that's not a good idea, and despite that
  218. # many books write the algorithm that way. During a heap pop, the last array
  219. # element is sifted in, and that tends to be large, so that comparing it
  220. # against values starting from the root usually doesn't pay (= usually doesn't
  221. # get us out of the loop early). See Knuth, Volume 3, where this is
  222. # explained and quantified in an exercise.
  223. #
  224. # Cutting the # of comparisons is important, since these routines have no
  225. # way to extract "the priority" from an array element, so that intelligence
  226. # is likely to be hiding in custom __cmp__ methods, or in array elements
  227. # storing (priority, record) tuples. Comparisons are thus potentially
  228. # expensive.
  229. #
  230. # On random arrays of length 1000, making this change cut the number of
  231. # comparisons made by heapify() a little, and those made by exhaustive
  232. # heappop() a lot, in accord with theory. Here are typical results from 3
  233. # runs (3 just to demonstrate how small the variance is):
  234. #
  235. # Compares needed by heapify Compares needed by 1000 heappops
  236. # -------------------------- --------------------------------
  237. # 1837 cut to 1663 14996 cut to 8680
  238. # 1855 cut to 1659 14966 cut to 8678
  239. # 1847 cut to 1660 15024 cut to 8703
  240. #
  241. # Building the heap by using heappush() 1000 times instead required
  242. # 2198, 2148, and 2219 compares: heapify() is more efficient, when
  243. # you can use it.
  244. #
  245. # The total compares needed by list.sort() on the same lists were 8627,
  246. # 8627, and 8632 (this should be compared to the sum of heapify() and
  247. # heappop() compares): list.sort() is (unsurprisingly!) more efficient
  248. # for sorting.
  249. def _siftup(heap, pos):
  250. endpos = len(heap)
  251. startpos = pos
  252. newitem = heap[pos]
  253. # Bubble up the smaller child until hitting a leaf.
  254. childpos = 2*pos + 1 # leftmost child position
  255. while childpos < endpos:
  256. # Set childpos to index of smaller child.
  257. rightpos = childpos + 1
  258. if rightpos < endpos and not cmp_lt(heap[childpos], heap[rightpos]):
  259. childpos = rightpos
  260. # Move the smaller child up.
  261. heap[pos] = heap[childpos]
  262. pos = childpos
  263. childpos = 2*pos + 1
  264. # The leaf at pos is empty now. Put newitem there, and bubble it up
  265. # to its final resting place (by sifting its parents down).
  266. heap[pos] = newitem
  267. _siftdown(heap, startpos, pos)
  268. def _siftdown_max(heap, startpos, pos):
  269. 'Maxheap variant of _siftdown'
  270. newitem = heap[pos]
  271. # Follow the path to the root, moving parents down until finding a place
  272. # newitem fits.
  273. while pos > startpos:
  274. parentpos = (pos - 1) >> 1
  275. parent = heap[parentpos]
  276. if cmp_lt(parent, newitem):
  277. heap[pos] = parent
  278. pos = parentpos
  279. continue
  280. break
  281. heap[pos] = newitem
  282. def _siftup_max(heap, pos):
  283. 'Maxheap variant of _siftup'
  284. endpos = len(heap)
  285. startpos = pos
  286. newitem = heap[pos]
  287. # Bubble up the larger child until hitting a leaf.
  288. childpos = 2*pos + 1 # leftmost child position
  289. while childpos < endpos:
  290. # Set childpos to index of larger child.
  291. rightpos = childpos + 1
  292. if rightpos < endpos and not cmp_lt(heap[rightpos], heap[childpos]):
  293. childpos = rightpos
  294. # Move the larger child up.
  295. heap[pos] = heap[childpos]
  296. pos = childpos
  297. childpos = 2*pos + 1
  298. # The leaf at pos is empty now. Put newitem there, and bubble it up
  299. # to its final resting place (by sifting its parents down).
  300. heap[pos] = newitem
  301. _siftdown_max(heap, startpos, pos)
  302. # If available, use C implementation
  303. try:
  304. from _heapq import *
  305. except ImportError:
  306. pass
  307. def merge(*iterables):
  308. '''Merge multiple sorted inputs into a single sorted output.
  309. Similar to sorted(itertools.chain(*iterables)) but returns a generator,
  310. does not pull the data into memory all at once, and assumes that each of
  311. the input streams is already sorted (smallest to largest).
  312. >>> list(merge([1,3,5,7], [0,2,4,8], [5,10,15,20], [], [25]))
  313. [0, 1, 2, 3, 4, 5, 5, 7, 8, 10, 15, 20, 25]
  314. '''
  315. _heappop, _heapreplace, _StopIteration = heappop, heapreplace, StopIteration
  316. _len = len
  317. h = []
  318. h_append = h.append
  319. for itnum, it in enumerate(map(iter, iterables)):
  320. try:
  321. next = it.next
  322. h_append([next(), itnum, next])
  323. except _StopIteration:
  324. pass
  325. heapify(h)
  326. while _len(h) > 1:
  327. try:
  328. while 1:
  329. v, itnum, next = s = h[0]
  330. yield v
  331. s[0] = next() # raises StopIteration when exhausted
  332. _heapreplace(h, s) # restore heap condition
  333. except _StopIteration:
  334. _heappop(h) # remove empty iterator
  335. if h:
  336. # fast case when only a single iterator remains
  337. v, itnum, next = h[0]
  338. yield v
  339. for v in next.__self__:
  340. yield v
  341. # Extend the implementations of nsmallest and nlargest to use a key= argument
  342. _nsmallest = nsmallest
  343. def nsmallest(n, iterable, key=None):
  344. """Find the n smallest elements in a dataset.
  345. Equivalent to: sorted(iterable, key=key)[:n]
  346. """
  347. # Short-cut for n==1 is to use min() when len(iterable)>0
  348. if n == 1:
  349. it = iter(iterable)
  350. head = list(islice(it, 1))
  351. if not head:
  352. return []
  353. if key is None:
  354. return [min(chain(head, it))]
  355. return [min(chain(head, it), key=key)]
  356. # When n>=size, it's faster to use sorted()
  357. try:
  358. size = len(iterable)
  359. except (TypeError, AttributeError):
  360. pass
  361. else:
  362. if n >= size:
  363. return sorted(iterable, key=key)[:n]
  364. # When key is none, use simpler decoration
  365. if key is None:
  366. it = izip(iterable, count()) # decorate
  367. result = _nsmallest(n, it)
  368. return map(itemgetter(0), result) # undecorate
  369. # General case, slowest method
  370. in1, in2 = tee(iterable)
  371. it = izip(imap(key, in1), count(), in2) # decorate
  372. result = _nsmallest(n, it)
  373. return map(itemgetter(2), result) # undecorate
  374. _nlargest = nlargest
  375. def nlargest(n, iterable, key=None):
  376. """Find the n largest elements in a dataset.
  377. Equivalent to: sorted(iterable, key=key, reverse=True)[:n]
  378. """
  379. # Short-cut for n==1 is to use max() when len(iterable)>0
  380. if n == 1:
  381. it = iter(iterable)
  382. head = list(islice(it, 1))
  383. if not head:
  384. return []
  385. if key is None:
  386. return [max(chain(head, it))]
  387. return [max(chain(head, it), key=key)]
  388. # When n>=size, it's faster to use sorted()
  389. try:
  390. size = len(iterable)
  391. except (TypeError, AttributeError):
  392. pass
  393. else:
  394. if n >= size:
  395. return sorted(iterable, key=key, reverse=True)[:n]
  396. # When key is none, use simpler decoration
  397. if key is None:
  398. it = izip(iterable, count(0,-1)) # decorate
  399. result = _nlargest(n, it)
  400. return map(itemgetter(0), result) # undecorate
  401. # General case, slowest method
  402. in1, in2 = tee(iterable)
  403. it = izip(imap(key, in1), count(0,-1), in2) # decorate
  404. result = _nlargest(n, it)
  405. return map(itemgetter(2), result) # undecorate
  406. if __name__ == "__main__":
  407. +
  408. −# Simple sanity test
  409. heap = []
  410. data = [1, 3, 5, 7, 9, 2, 4, 6, 8, 0]
  411. for item in data:
  412. heappush(heap, item)
  413. sort = []
  414. while heap:
  415. sort.append(heappop(heap))
  416. print sort
  417. import doctest
  418. doctest.testmod()

530 检测大写字母

520. 检测大写字母

给定一个单词,你需要判断单词的大写使用是否正确。

我们定义,在以下情况时,单词的大写用法是正确的:

全部字母都是大写,比如”USA”。

单词中所有字母都不是大写,比如”leetcode”。

如果单词不只含有一个字母,只有首字母大写, 比如 “Google”。

否则,我们定义这个单词没有正确使用大写字母。

示例 1:

输入: “USA”

输出: True

示例 2:

输入: “FlaG”

输出: False

来源:力扣(LeetCode)

链接:https://leetcode-cn.com/problems/detect-capital

著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。

对于这道题,我一开始使用的是C++的方法,非常的费脑子,算是按照过程式的思维去考虑到所有可能的情况,并总结规律,最后通过两个bool的flag来维系状态

class Solution {
public:
    bool detectCapitalUse(string word) {
        if(word.size() == 1)
            return true;

        int first = word[0];
        bool no_capitals = false;
        if(first >= 'a' && first <= 'z')
            no_capitals = true;

        int second = word[1];
        bool always_capitals = false;

        if(second >= 'A' && second <= 'Z')
        {
            if(no_capitals)
                return false;
            always_capitals = true;
        }

        if(second >= 'a' && second <= 'z')
            no_capitals = true;

        for(int i = 2; i < word.size(); i++)
        {
            if(word[i] >= 'A' && word[i] <= 'Z')
            {
                if(no_capitals)
                    return false;
            }

            if(word[i] >= 'a' && word[i] <= 'z')
            {
                if(always_capitals)
                    return false;
            }
        }

        return true;
    }
};

下面这种方法是我在评论区中所看到的,采用python,非常的简洁

def detectCapitalUse(self, word):
    return word.isupper() or word.islower() or word.istitle()